ifdef IS_LIB

CFLAGS  += -fPIC # for amd64

all:	lib$(NAME).so ../_include/$(NAME).h

lib$(NAME).so: $(OBJ) $(TESTDIR)
	@echo "LD -shared $@"; $(CC) $(LDFLAGS) -shared $(OBJ) $(LOADLIBES) $(LDLIBS) -o $@.$(VERSION)
	ln -sf $@.$(VERSION) $@
	cp -p lib*so* ../_lib

../_include/$(NAME).h:	$(HDR) $(TESTDIR)
	cat $(HDR) > ../_include/$(NAME).h

install: lib$(NAME).so ../_include/$(NAME).h $(TESTDIR)
	install ../_include/$(NAME)*.h $(PREFIX)/include/
	install lib$(NAME).so.$(VERSION) $(PREFIX)/lib
	ln -sf  lib$(NAME).so.$(VERSION) $(PREFIX)/lib/lib$(NAME).so
	@echo '** Do not forget to run ldconfig!'
#	ldconfig

$(PRG):	%:  %.o lib$(NAME).so
	@echo "LD $@"; $(CC) $(TLDFLAGS) $(LDFLAGS) $@.o -l$(NAME) $(LOADLIBES) $(LDLIBS) -o $@

else
# not lib

all: $(NAME) lib.a

lib.a:	$(OBJ)

$(NAME): $(OBJ) $(TESTDIR)
	@echo "LD $@"; $(CC) -L../_lib $(LDFLAGS) $(OBJ) $(LOADLIBES) $(LDLIBS) -o $@
	cp -p $@ ../_bin

$(PRG): %: %.o lib.a
	@echo "LD $@"; $(CC) $(LDFLAGS) $@.o $(filter-out $(NAME).o,$(OBJ)) $(LOADLIBES) $(LDLIBS) -o $@

install: $(NAME) $(TESTDIR)
	install    $(NAME)     $(PREFIX)/bin/$(NAME)

endif
# both lib and program dirs

prg:	$(PRG)

clean:	
	-rm -f *.o *.so *~ *.core $(NAME) *.so.$(VERSION) $(PRG) lib.a depend.mk $^

dep depend depend.mk: $(MSRC) $(SRC) $(HDR)
	@echo "CC -MM -MG $(SRC) > depend.mk"; $(CC) $(CFLAGS) -MM -MG $(MSRC) $(SRC) > depend.mk

%.o:	%.c
	@echo CC $<; $(CC) -c $(CFLAGS) $(CPPFLAGS) $(HASGRANTPT) $< -o $@

show:
	@echo CC = $(CC) -c $(CFLAGS) $(CPPFLAGS) FILE.c -o FILE.o | fold -w72 -s
	@echo LD = $(CC) $(LDFLAGS) FILEs.o $(LOADLIBES) $(LDLIBS) -o FILE
	@echo

$(TESTDIR):
	mkdir $@

-include depend.mk

FORCE:	;
